#include "stdafx.h"
#include "NeMessenger.h"
#include "SMSSendDlg.h"

IMPLEMENT_DYNAMIC(CSMSSendDlg, CDialog)

CSMSSendDlg::CSMSSendDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSMSSendDlg::IDD, pParent),m_pSMSController(new CSMSController(this)),m_bShowContentEdit(false)
{
	 m_rcRecveierText.SetRect(155, 35, 210, 50);
	 m_rcRecveierLimitText.SetRect(155, 51, 343, 71);
	 m_rcSenderText.SetRect(155, 204, 260, 224);
	 m_rcByteCheckText.SetRect(40, 223, 121, 240);
	 m_rcContent.SetRect(15, 33, 144, 216);
	 m_rcSMSlength.SetRect(15, 215, 144, 244);
     m_pDropTarget = NULL;
     m_pSMSController = NULL;
}

CSMSSendDlg::~CSMSSendDlg()
{
	if (NULL != m_pDropTarget) 
		delete m_pDropTarget;
	if (NULL != m_pSMSController )
		delete m_pSMSController;

}

void CSMSSendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_CONTENT, m_edContent);
	DDX_Control(pDX, IDC_EDIT_SENDER, m_edSender);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_btnSend);
	DDX_Control(pDX, IDC_BUTTON_CANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_EDIT_ADD_PHONE, m_edAddPhoneNumber);
	DDX_Control(pDX, IDC_BUTTON_ADD_PHONE, m_btnAddPhoneNumber);
	DDX_Control(pDX, IDC_BUTTON_CLOSE, m_btnClose);
}

BEGIN_MESSAGE_MAP(CSMSSendDlg, CDialog)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CSMSSendDlg::OnBnClickedButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, &CSMSSendDlg::OnBnClickedButtonCancel)
	ON_WM_LBUTTONDBLCLK()
	ON_MESSAGE(WM_SMSDLG_RECEIVERLIST_DELUSER, OnReciverListDelUser)
	ON_WM_NCDESTROY()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BUTTON_ADD_PHONE, &CSMSSendDlg::OnBnClickedButtonAddPhone)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, &CSMSSendDlg::OnBnClickedButtonClose)
END_MESSAGE_MAP()

void CSMSSendDlg::InitSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\IMAGES\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}
BOOL CSMSSendDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitSkin();	
	m_strSMSLength.Format(L"0Byte/80Byte");
	
	m_edContent.SetEvent(OnEventContent,this);
	m_edContent.SetFont(&g_ftDefault13PX);

	m_edAddPhoneNumber.SetEvent(OnEventPhoneNumber,this);
	m_edSender.SetEvent(OnEventPhoneNumber,this);

	ModifyStyle(0, WS_CLIPCHILDREN);

	// ڱڽ ȭȣ ? 
	// ʿ
	GT_MY_USER_DATA myUserInfo;
	g_pMessengerActor->GetMyUserInfo(myUserInfo);
	CString strCellPhone(myUserInfo.sMyPage.strCphNo);

	SetWindowText(LoadStringFromResource(IDS_STRING293));

	m_edSender.SetWindowText(strCellPhone);
	m_btnAddPhoneNumber.SetWindowText(LoadStringFromResource(IDS_STRING581)); 
	m_btnSend.SetWindowText(LoadStringFromResource(IDS_STRING577));
	m_btnCancel.SetWindowText(LoadStringFromResource(IDS_STRING582));
	m_btnClose.SetWindowText(LoadStringFromResource(IDS_STRING569));

	CString strTmpClassName = _T("");
	strTmpClassName.Format(_T("Ntalk_RecvList_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rcRecvList(0, 0, 0, 0);
	if(m_wndRecvList.Create(strTmpClassName,_T("Ntalk_recv_List"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rcRecvList, this, ID_RECV_LIST ))
	{
		m_wndRecvList.SetImgDeletePath(_T("New_Info_UserMgr_Delete.png"), _T("New_Info_UserMgr_Delete_Over.png"));
		m_wndRecvList.SetFontConfig(g_defaultFontFaceName, 9, FontStyleRegular, Color(255, 0, 0, 0));

	}

	m_edContent.MoveWindow(27, 50, 108, 150);
	m_edAddPhoneNumber.MoveWindow(155, 183, 198, 20);
	m_btnAddPhoneNumber.MoveWindow(353, 182, 33, 23);
	m_edSender.MoveWindow(155, 225, 228, 20);
	m_btnSend.MoveWindow(109, 281, 58, 28);
	m_btnCancel.MoveWindow(169, 281, 58, 28);
	m_btnClose.MoveWindow(229,281,58,28);
	m_btnSend.SetFont(&g_ftDefault12PX);
	m_btnCancel.SetFont(&g_ftDefault12PX);
	m_btnClose.SetFont(&g_ftDefault12PX);
	m_btnAddPhoneNumber.SetFont(&g_ftDefault12PX);
	m_wndRecvList.MoveWindow(155, 74, 230, 105);

	MoveWindow(0, 0, DEF_SMS_DLG_SIZE_CX, DEF_SMS_DLG_SIZE_CY);
	CenterWindow();
	__ResourceLoad(FALSE);
	SetDragAndDrop();

	//g_pMessengerActor->RegisterObserver(this);
	g_pMessengerActor->GetWASActor()->RegisterObserver(this);	
	AddSMSReceiver();

	return TRUE;  
}
void CSMSSendDlg::__ResourceLoad(BOOL bInit)
{	

}

BOOL CSMSSendDlg::PreTranslateMessage(MSG* pMsg)
{

	if (m_hWnd != pMsg->hwnd && !IsChild(FromHandle(pMsg->hwnd))) //It means the msg has No matter with memo window, return false.
	{

		return FALSE;
	}

	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_RETURN
			&& m_edContent.GetSafeHwnd() != ::GetFocus())
		{			
			return TRUE;
		}
	}
	else if( IsCloseMsg(pMsg) )
	{
		CloseSMSDialog();
		return TRUE;
	}

	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CSMSSendDlg::Create(const std::vector<CSMSModel::SMSReceiverInfo>& receiverVector, UINT nIDTemplate,CWnd* pParentWnd/*  =NULL */)
{
	m_receiverVector = receiverVector;
	return CDialog::Create(nIDTemplate, pParentWnd);
}

BOOL CSMSSendDlg::OnEraseBkgnd(CDC* pDC)
{
    CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	NMMemDC memDC;
	memDC.CreateCompatibleDC(pDC, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), SMS_DLG_BG_COLOR);	
	memDC.FillSolidRect(0, 0, DEF_SMS_DLG_SIZE_CX, SMS_DLG_BORDER_PIXEL, SMS_DLG_CONTROL_BORDER_COLOR);
	memDC.FillSolidRect(0, 274, DEF_SMS_DLG_SIZE_CX, SMS_DLG_BORDER_PIXEL, SMS_DLG_CONTROL_BORDER_COLOR);
	CFont *pOldFont = memDC.SelectObject(&g_ftDefault13PX);
	COLORREF oldColor = memDC.SetTextColor(SMS_DLG_TEXT_BG_COLOR);
	pDC->SetBkMode(TRANSPARENT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING470), m_rcRecveierText, DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING471), m_rcSenderText, DT_LEFT);
	pDC->SelectObject(&g_ftDefault9PT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING472), m_rcRecveierLimitText, DT_LEFT);
	CRect rcSMSLength = m_rcSMSlength;
	CRect rcContent = m_rcContent;
	memDC.FillSolidRect(rcSMSLength, SMS_DLG_CONTROL_BORDER_COLOR);
	memDC.FillSolidRect(rcContent, SMS_DLG_CONTROL_BORDER_COLOR);
	rcSMSLength.DeflateRect(1, 1);
	rcContent.DeflateRect(1, 1);
	memDC.FillSolidRect(rcSMSLength, SMS_DLG_BG_COLOR);
	memDC.FillSolidRect(rcContent, SMS_DLG_BG_COLOR);

	CRect rcEditSender(0, 0, 0, 0);
	m_edSender.GetWindowRect(rcEditSender);
	ScreenToClient(rcEditSender);
	rcEditSender.InflateRect(SMS_DLG_BORDER_PIXEL, SMS_DLG_BORDER_PIXEL);
	rcEditSender.OffsetRect(0,0);
	CPen penEditBox;
	penEditBox.CreatePen(PS_SOLID, SMS_DLG_BORDER_PIXEL, SMS_DLG_CONTROL_BORDER_COLOR);
	CPen *pOldpen = memDC.SelectObject(&penEditBox);
	memDC.Rectangle(rcEditSender);

	CRect rcAddPhoneNumber(0, 0, 0, 0);
	m_edAddPhoneNumber.GetWindowRect(rcAddPhoneNumber);
	ScreenToClient(rcAddPhoneNumber);
	rcAddPhoneNumber.InflateRect(SMS_DLG_BORDER_PIXEL, SMS_DLG_BORDER_PIXEL);
	memDC.Rectangle(rcAddPhoneNumber);

	CRect rcReceiverListBox(0, 0, 0, 0);
	m_wndRecvList.GetWindowRect(rcReceiverListBox);
	ScreenToClient(rcReceiverListBox);
	rcReceiverListBox.InflateRect(SMS_DLG_BORDER_PIXEL, SMS_DLG_BORDER_PIXEL);
	memDC.Rectangle(rcReceiverListBox);
	memDC.SelectObject(&g_ftDefault12PX);
	memDC.SetTextColor(SMS_DLG_TEXT_BG_COLOR);
	memDC.DrawText(m_strSMSLength,m_rcByteCheckText, DT_LEFT);

	if (!m_bShowContentEdit)
	{
		m_edContent.ShowWindow(SW_HIDE);
		CRect rcEditBox(0, 0, 0, 0);
		m_edContent.GetWindowRect(rcEditBox);
		ScreenToClient(rcEditBox);
		memDC.DrawText(LoadStringFromResource(IDS_STRING546), rcEditBox, DT_CENTER |DT_VCENTER);
	}


	pDC->BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldpen);
	memDC.SetTextColor(oldColor);	
	memDC.SelectObject(pOldFont);

	penEditBox.DeleteObject();

	return FALSE;
}

void CSMSSendDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

}

void CSMSSendDlg::OnBnClickedButtonSend()
{
	if(m_pSMSController->GetCurrentReceiverCount() <1)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING550));
		return;
	}
	UpdateData(TRUE);
	CString strContent;
	m_edContent.GetWindowText(strContent);
	if (L"" == strContent)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING559));
		return;
	}

	CString strSender;
	m_edSender.GetWindowText(strSender);
	strSender.Remove('+');
	strSender.Remove('-');

	if (L"" == strSender)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING558) );
		return;
	}

	trid_t trid;
	g_pMessengerActor->GetWASActor()->RequestSMS(strContent, m_pSMSController->GetReceiverTelNums(), strSender, &trid );
	m_tridList.push_back(trid);
}

void CSMSSendDlg::OnBnClickedButtonCancel()
{
	if (m_bShowContentEdit)
	{
		m_edContent.SetWindowText(L"");
		UpdateData(FALSE);
	}
}



void CSMSSendDlg::OnEventContent(int nID, int nBytes, void* pUser)
{
	CSMSSendDlg* pClass = (CSMSSendDlg*)pUser;
	if (nID ==CEditBytes::ID_MAX)
	{
		NMessageBox(pClass, LoadStringFromResource(IDS_STRING547));
	}
	else if (nID ==CEditBytes::ID_EDIT_CHANGE)
	{
		CString str;
		pClass->m_strSMSLength.Format(L"%dByte/80Byte", nBytes);

	}
	//Ʈ Ʈ ణ Ѿ ٸ  ĳ  ִ
	//ذ  ĳ  κ ٽ ׷ش. [2012.7.19 yangjae.park@nhn.com]
	CRect rcRedraw(0, 0, 0, 0);
	rcRedraw.SetRect(pClass->m_rcContent.right - 4, pClass->m_rcContent.top - 1, 3, pClass->m_rcContent.Height() - 2);
	pClass->InvalidateRect(rcRedraw);
	pClass->InvalidateRect(pClass->m_rcByteCheckText);
}

bool CSMSSendDlg::IsCloseMsg( MSG* pMsg )
{
	bool result = false;
	if( (pMsg->message == WM_CLOSE) ||
		(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE) || 
		(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4)||
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))
		result = true;

	return result;
}

void CSMSSendDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{

	CDialog::OnLButtonDblClk(nFlags, point);
}

void CSMSSendDlg::OnNcDestroy()
{
	CDialog::OnNcDestroy();
}

void CSMSSendDlg::PostNcDestroy()
{
	CDialog::PostNcDestroy();
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	

	delete this;
}

bool CSMSSendDlg::OnGTWASActor_ResponseSMS( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_SMS_DATA &smsCount )
{
	std::list<trid_t>::iterator findTrid = std::find(m_tridList.begin(), m_tridList.end(), trid);
	if (findTrid == m_tridList.end())
		return true;

	m_tridList.remove(*findTrid);

	if (eErrorCode == wasError_None)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING548));
	}
	else if(eErrorCode == wasError_Invalid_Authorization)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING_SMS_INVALID_AUTHORIZATION));
	}
	else if(eErrorCode == wasError_Lack_Point)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING_SMS_LACK_SEND_POINT));
	}
	else
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING549));
	}

	return false;
}

void CSMSSendDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (point.x >m_rcContent.left && point.x <m_rcContent.right &&
		point.y>m_rcContent.top && point.y<m_rcContent.bottom)
	{
		m_bShowContentEdit = TRUE;
		m_edContent.ShowWindow(SW_SHOW);
		m_edContent.SetFocus();
	}
	CRect rcRedraw(0, 0, 0, 0);
	rcRedraw.top = m_rcContent.top - 2;
	rcRedraw.left = m_rcContent.left - 2;
	rcRedraw.right = m_rcContent.right + 2;
	rcRedraw.bottom=m_rcContent.bottom + 2;
	InvalidateRect(rcRedraw);

	__super::OnLButtonDown(nFlags, point);
}

void CSMSSendDlg::SetDragAndDrop()
{
	if (NULL != m_pSMSController)
		m_pDropTarget = new SMSDropTarget(m_pSMSController);

	if (NULL != m_pDropTarget)
		m_pDropTarget->Register(&m_wndRecvList);
}

LRESULT CSMSSendDlg::OnReciverListDelUser( WPARAM wParam, LPARAM lParam )
{
	CWndSMSRecvList::USER_ITEM_INFO* pUserInfo = (CWndSMSRecvList::USER_ITEM_INFO*)lParam;
	if (!pUserInfo)
		return 0L;
	m_pSMSController->RemoveSMSReceiver(pUserInfo->strID);

	return 1L;
}



LRESULT CSMSSendDlg::OnReciverListUserInfo( WPARAM wParam, LPARAM lParam )
{

	return 1L;
}

void CSMSSendDlg::CloseSMSDialog()
{
	
	//g_pMessengerActor->UnRegisterObserver(this);

	GET_APP()->m_pSMSDialogManager->Remove(this);
	this->DestroyWindow();
}

void CSMSSendDlg::OnBnClickedButtonAddPhone()
{
	CString strPhoneNumber;
	m_edAddPhoneNumber.GetWindowText(strPhoneNumber);

	if (L""==strPhoneNumber)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING551));
		return;
	}
	CSMSModel::SMSReceiverInfo receiverInfo;
	receiverInfo.strCellPhone = strPhoneNumber;
	receiverInfo.strID = strPhoneNumber;
	receiverInfo.strName = strPhoneNumber;

	if(m_pSMSController->GetCurrentReceiverCount()  >= 50)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING469));
		return;
	}

	if(m_pSMSController->AddSMSReceiver(receiverInfo.strID, receiverInfo.strName, receiverInfo.strCellPhone))
	{
		m_wndRecvList.AddUserMgrItem(receiverInfo.strID, receiverInfo.strName, receiverInfo.strCellPhone );
	}
}

void CSMSSendDlg::OnEventPhoneNumber( int nID, void* pUser )
{
	CSMSSendDlg* pClass = (CSMSSendDlg*)pUser;
	if (nID ==CEditPhoneNumber::EID_NOTINPUT)
	{
		NMessageBox(pClass, LoadStringFromResource(IDS_STRING552));
	}
	else if (nID ==CEditPhoneNumber::EID_MAX)
	{
		NMessageBox(pClass, LoadStringFromResource(IDS_STRING553));
	}

}


void CSMSSendDlg::OnBnClickedButtonClose()
{
	CloseSMSDialog();
}

void CSMSSendDlg::AddSMSReceiver()
{
	std::vector<CSMSModel::SMSReceiverInfo>::const_iterator receiverIterator = m_receiverVector.begin();
	int nReceiverCount=1;
	for (; receiverIterator != m_receiverVector.end(); ++receiverIterator)
	{
		if (nReceiverCount > MAXSMSRECEIVER)
		{
			NMessageBox(this, LoadStringFromResource(IDS_STRING469));
			break;
		}
		CSMSModel::SMSReceiverInfo receiverInfo = *receiverIterator;
		if (L"" ==receiverInfo.strCellPhone)
		{
			//CString strErrMsg;
			//strErrMsg.Format(LoadStringFromResource(IDS_STRING562),receiverInfo.strName,receiverInfo.strName);
			//NMessageBox(this,strErrMsg);
		}
		else
		{
			m_wndRecvList.AddUserMgrItem(receiverInfo.strID, receiverInfo.strName, receiverInfo.strCellPhone );
			m_pSMSController->AddSMSReceiver(receiverInfo.strID, receiverInfo.strName, receiverInfo.strCellPhone);
			nReceiverCount++;
		}

	}
}